#ifndef __VAPI
#define __VAPI

#include <vdi.h>

typedef struct
{
  unsigned short Version ; /* 0x0100 for example */
  unsigned short StrSize ;

  void  *Global ;              /* Global VISION array for AES, useful with MT_AES */
  void cdecl (*GEMMessageLoop)(void *msg) ; /* Call this if your LDV uses AES and */
                                            /* you want VISION to handle some AES */
                                            /* messages (redraws for examples)    */
  char RFU[116] ;
}
VAPI_HEADER ;

typedef struct
{
  VAPI_HEADER Header ;

  /* Progress Interface */
  void cdecl (*PrSetProg)(long pc) ;
  void cdecl (*PrOptimize)(long mask) ;
  long PrRFU[10] ;

  /* Raster Interface */
  void cdecl (*RaImgWhite)(MFDB *img) ;
  void cdecl (*RaTCConvert)(MFDB *img) ;
  void cdecl (*RaTCInvConvert)(MFDB *img) ;
  void cdecl (*RaInd2RasterInit)(MFDB *out, long width) ;
  void cdecl (*RaInd2Raster)(unsigned char *indexes, long nb_indexes) ;
  void cdecl (*RaRaster2Ind)(short *pt_raster, long nb_pts, long nplans, unsigned char *out) ;
  unsigned char * cdecl (*RaGetTOS2VDIArray)(long nplanes) ;
  unsigned char * cdecl (*RaGetVDI2TOSArray)(long nplanes) ;
  long cdecl (*RaIs15Bits)(void) ;

  long RaRFU[50] ;

  /* More interfaces to come ! */
}
VAPI ;

#endif
